//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%41FE88A60338.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%41FE88A60338.cm

//## begin module%41FE88A60338.cp preserve=no
//## end module%41FE88A60338.cp

//## Module: ModularCounter%41FE88A60338; Package specification
//## Subsystem: XSUtil::Numerics%41E6D0F3003C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Numerics/ModularCounter.h

#ifndef MODULARCOUNTER_H
#define MODULARCOUNTER_H 1

//## begin module%41FE88A60338.additionalIncludes preserve=no
//## end module%41FE88A60338.additionalIncludes

//## begin module%41FE88A60338.includes preserve=yes
//## end module%41FE88A60338.includes

//## begin module%41FE88A60338.declarations preserve=no
//## end module%41FE88A60338.declarations

//## begin module%41FE88A60338.additionalDeclarations preserve=yes
#include <xsTypes.h>
//## end module%41FE88A60338.additionalDeclarations


//## Modelname: XSUtil::Numerics%3F6F5A7603D4
namespace Numerics {
    //## begin Numerics%3F6F5A7603D4.initialDeclarations preserve=yes
    //## end Numerics%3F6F5A7603D4.initialDeclarations

    //## begin Numerics::ModularCounter%41FE890F0099.preface preserve=yes
    //## end Numerics::ModularCounter%41FE890F0099.preface

    //## Class: ModularCounter%41FE890F0099
    //## Category: XSUtil::Numerics%3F6F5A7603D4
    //## Subsystem: XSUtil::Numerics%41E6D0F3003C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ModularCounter 
    {
      //## begin Numerics::ModularCounter%41FE890F0099.initialDeclarations preserve=yes
      //## end Numerics::ModularCounter%41FE890F0099.initialDeclarations

      public:
        //## Constructors (specified)
          //## Operation: ModularCounter%41FE8AD00387
          ModularCounter (const IntegerArray& bases);

        //## Destructor (generated)
          ~ModularCounter();

        //## Assignment Operation (generated)
          ModularCounter & operator=(const ModularCounter &right);


        //## Other Operations (specified)
          //## Operation: reset%41FE8BE90313
          void reset ();

          //## Operation: operator++%41FE8D5F00F6
          ModularCounter& operator ++ ();

          //## Operation: operator++%41FE8D9902A4
          const ModularCounter operator ++ (int i);

          //## Operation: operator--%41FE8DCC018A
          ModularCounter& operator -- ();

          //## Operation: operator--%41FE8DE40274
          const ModularCounter operator -- (int i);

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: bases%41FE8B10022A
          const IntegerArray& bases () const;

          //## Attribute: counter%41FE8C2D01F0
          const IntegerArray& counter () const;

          //## Attribute: totalCount%41FE929B00D0
          size_t totalCount () const;

        // Additional Public Declarations
          //## begin Numerics::ModularCounter%41FE890F0099.public preserve=yes
          //## end Numerics::ModularCounter%41FE890F0099.public

      protected:
        // Additional Protected Declarations
          //## begin Numerics::ModularCounter%41FE890F0099.protected preserve=yes
          //## end Numerics::ModularCounter%41FE890F0099.protected

      private:

        //## Other Operations (specified)
          //## Operation: adjust%41FE8D4600B9
          void adjust ();

          //## Operation: rollBack%41FE97EF032E
          void rollBack ();

        // Additional Private Declarations
          //## begin Numerics::ModularCounter%41FE890F0099.private preserve=yes
          //## end Numerics::ModularCounter%41FE890F0099.private

      private: //## implementation
        // Data Members for Class Attributes

          //## begin Numerics::ModularCounter::bases%41FE8B10022A.attr preserve=no  public: IntegerArray {U} 
          IntegerArray m_bases;
          //## end Numerics::ModularCounter::bases%41FE8B10022A.attr

          //## begin Numerics::ModularCounter::counter%41FE8C2D01F0.attr preserve=no  public: IntegerArray {U} 
          IntegerArray m_counter;
          //## end Numerics::ModularCounter::counter%41FE8C2D01F0.attr

          //## begin Numerics::ModularCounter::totalCount%41FE929B00D0.attr preserve=no  public: size_t {U} 
          size_t m_totalCount;
          //## end Numerics::ModularCounter::totalCount%41FE929B00D0.attr

        // Additional Implementation Declarations
          //## begin Numerics::ModularCounter%41FE890F0099.implementation preserve=yes
          //## end Numerics::ModularCounter%41FE890F0099.implementation

    };

    //## begin Numerics::ModularCounter%41FE890F0099.postscript preserve=yes
    //## end Numerics::ModularCounter%41FE890F0099.postscript

    // Class Numerics::ModularCounter 


    //## Other Operations (inline)
    inline void ModularCounter::reset ()
    {
      //## begin Numerics::ModularCounter::reset%41FE8BE90313.body preserve=yes
       m_counter = IntegerArray(m_counter.size(), 0);
       m_totalCount = 0;
      //## end Numerics::ModularCounter::reset%41FE8BE90313.body
    }

    //## Get and Set Operations for Class Attributes (inline)

    inline const IntegerArray& ModularCounter::bases () const
    {
      //## begin Numerics::ModularCounter::bases%41FE8B10022A.get preserve=no
      return m_bases;
      //## end Numerics::ModularCounter::bases%41FE8B10022A.get
    }

    inline const IntegerArray& ModularCounter::counter () const
    {
      //## begin Numerics::ModularCounter::counter%41FE8C2D01F0.get preserve=no
      return m_counter;
      //## end Numerics::ModularCounter::counter%41FE8C2D01F0.get
    }

    inline size_t ModularCounter::totalCount () const
    {
      //## begin Numerics::ModularCounter::totalCount%41FE929B00D0.get preserve=no
      return m_totalCount;
      //## end Numerics::ModularCounter::totalCount%41FE929B00D0.get
    }

} // namespace Numerics

//## begin module%41FE88A60338.epilog preserve=yes
//## end module%41FE88A60338.epilog


#endif
